
#####Classification Reliability#####
GDINA::CA(HODINA1)
#####Validity Evidence######
#1. Use the problem-solving item scores in the student questionnaire 
cogs <- read_sas("cogs.sas7bdat",NULL)
                   
#2. Use the literacy and math scores
#generate IDs
cogs[,217]<-paste0(cogs$CNT,cogs$SCHOOLID,cogs$StIDStd)
colnames(cogs)[217]<-"ID"

cogsdata<-cogs[cogs$ID%in%responsedata$ID,]
cogsdata<-cogsdata[order(cogsdata$ID),]

#same people
identical(unique(cogsdata$ID),responsedata$ID)

#3. Correlations
#####Multiple Item Outcome Data Analysis####

#"CP002Q06"  "CP002Q07"  "CP002Q08" not completed by USA students
#"CP007Q01"  "CP007Q02"  "CP007Q03T" not completed by USA students
#"CP025Q01"  "CP025Q02" "CP038Q01"  "CP038Q02" 
#"CP038Q03"
rs<-responses[,c(1:9,10:15,27,28,47:49)]
rs$ID<-paste0(rs$CNT,rs$SCHOOLID,rs$StIDStd)
rs<-rs[rs$ID%in%data_clean$ID,c(16:21)]
#both N/A=7 and unreached = 8 are treated as NA

rs$CP025Q01[which(rs$CP025Q01==7)]<-NA
rs$CP025Q02[which(rs$CP025Q02==7|rs$CP025Q02==8)]<-NA
rs$CP038Q03[which(rs$CP038Q03==7)]<-NA
apply(rs[,c(1:5)],2,table)

saveRDS(rs,"multipleItems.rds")
multipleItems<-readRDS("multipleItems.rds")
#fit rasch+PCM
install.packages("TAM")
library(TAM)
multipleItems<-multipleItems[,c(1:5)]
multipleItems<-apply(multipleItems,2,as.numeric)
eap<-tam.mml(multipleItems,irtmodel = "Rasch")
sco.eap<-eap$person

cor.test(sco.eap[,6],CDM_ability)#correlation 0.674 (p < 0.001). 
tam.modelfit(eap)

#estimate math/reading/science ability
install.packages("TAM")
library(TAM)
mathdata<-cogsdata[,c(9:117)]
mathdata[mathdata==7|mathdata==8]<-NA
#remove columns with all NAs
mathdata <- mathdata[,colSums(is.na(mathdata))<nrow(mathdata)]
#rows with all NAs
mathNA<-as.numeric(rownames(mathdata[which(apply(mathdata,1,function(x) sum(!is.na(x)==TRUE))==0),]))
mathNotNA<-as.numeric(rownames(mathdata[which(apply(mathdata,1,function(x) sum(!is.na(x)==TRUE))!=0),]))

readingdata<-cogsdata[,c(118:161)]
readingdata[readingdata==7|readingdata==8]<-NA
readNA<-as.numeric(rownames(readingdata[which(apply(readingdata,1,function(x) sum(!is.na(x)==TRUE))==0),]))
readNotNA<-as.numeric(rownames(readingdata[which(apply(readingdata,1,function(x) sum(!is.na(x)==TRUE))!=0),]))
NotNA<-intersect(mathNotNA,readNotNA)

mathdataNotNA<-mathdata[NotNA,]
readdataNotNA<-readingdata[NotNA,] 
mathdataNotNA<-apply(mathdataNotNA,2,as.numeric)
readdataNotNA<-apply(readdataNotNA,2,as.numeric)

math.1pl<- tam.mml(mathdataNotNA,irtmodel = "Rasch")
mathscore<-math.1pl$person
cor.test(mathscore[,6], CDM_ability[NotNA])

read.1pl<-tam.mml(readdataNotNA,irtmodel = "Rasch") 
readscore<-read.1pl$person
cor.test(readscore[,6], CDM_ability[NotNA])


#unsupervised methods
#####SOM####
#k=number of clusters
install.packages("kohonen")
library(kohonen)
library(stats)
clustertrain<-full_data
set.seed(1234)
###number of cluster =3
k=3
som_k3=som(as.matrix(clustertrain), grid = somgrid(k, 1, "hexagonal"),rlen=2000,alpha=c(.05,.01))
                                                  

som_result_k3<-som_k3$unit.classif
table(som_result_k3,responsedata$CP038Q01)

kmeans_k3=kmeans(clustertrain,centers=(k), nstart=2000)
kmeans_result_k3<-kmeans_k3$cluster
table(kmeans_result_k3,responsedata$CP038Q01)

###number of cluster =26
set.seed(1234)
k=26
som_k26=som(as.matrix(clustertrain), grid = somgrid(k, 1, "hexagonal"),rlen=2000,alpha=c(.05,.01))

                                                   
som_result_k26<-som_k26$unit.classif
table(som_result_k26,responsedata$CP038Q01)
write.csv(table(som_result_k26,responsedata$CP038Q01),"som.csv",row.names = FALSE)
#####k-means#####
kmeans_k26=kmeans(full_data,centers=(k), nstart=20, iter.max = 10)
kmeans_result_k26<-kmeans_k26$cluster
table(kmeans_result_k26,responsedata$CP038Q01)
write.csv(table(kmeans_result_k26,responsedata$CP038Q01),"kmeans.csv",row.names = FALSE)



