#####Retrieve and Clean PISA Datasets#####
#347648 obs, 11 variables
setwd("data file path")
cp038q01<-read.csv("CBA_cp038q01_logs12_SPSS.csv",
                   header  = TRUE,stringsAsFactors = FALSE)

#Singapore, USA, Austria, Turkey
#43397 obs, 11 variables
data<-cp038q01[which(cp038q01$cnt=="USA"|cp038q01$cnt=="SGP"|cp038q01$cnt=="AUS"|cp038q01$cnt=="TUR"),]
data_clean<-data[-which(is.na(data$schoolid)==TRUE),]
#sum(is.na(data_clean$schoolid)==TRUE)
#sum(is.na(data$schoolid)==TRUE)

#Change NULL into Start or End
for (i in 1: length(data_clean$event_value))
{
  if (data_clean$event_value[i]=="NULL" &data_clean$event[i]=="START_ITEM")
  {data_clean$event_value[i]<-"Start"}
  if (data_clean$event_value[i]=="NULL" &data_clean$event[i]=="END_ITEM")
  {data_clean$event_value[i]<-"End"}
}
# sum(data_clean$event_value=="NULL")
 sum(data_clean$event_value=="Start")#3765
# sum(data_clean$event_value=="End")


#load the item response data
#load SAS data (use R Import Dataset)
install.packages("haven")
library(haven)
cpdata <- read_sas("itemResponse.sas7bdat",NULL)
                         
responses<-cpdata[which(cpdata$CNT=="USA"|cpdata$CNT=="SGP"|
                          cpdata$CNT=="AUS"|cpdata$CNT=="TUR"),]
#keep ID variables and item responses
cp038q01_rs<-responses[,c(1:9,47)]

# create unique IDs in process data and response data
install.packages("stringr")
library(stringr)
data_clean$schoolid<-str_pad(data_clean$schoolid, 7, pad = "0")
data_clean$StIDStd<-str_pad(data_clean$StIDStd, 5, pad = "0")
data_clean[,12]<-paste0(data_clean$cnt,data_clean$schoolid,data_clean$StIDStd)
colnames(data_clean)[12]<-"ID"

cp038q01_rs$ID<-paste0(cp038q01_rs$CNT,cp038q01_rs$SCHOOLID,cp038q01_rs$StIDStd)

#unreached people IDs
unreached<-cp038q01_rs[which(cp038q01_rs$CP038Q01=="8"),]$ID
#delete unreached people in response data (CP038Q01=="8")
cp038q01_rs<-cp038q01_rs[-which(cp038q01_rs$CP038Q01=="8"),]

#further delete 5 people not reached in process data
data_clean<-data_clean[-which(data_clean$ID%in%unreached),]
length(unique(data_clean$ID))#3760

#merge process data and item respones data
#get the students have both item response data and process data
responsedata<-cp038q01_rs[cp038q01_rs$ID%in%data_clean$ID,]
responsedata<-responsedata[order(responsedata$ID),]
data_clean<-data_clean[order(data_clean$ID),]
#student ID for the remaining 3670 students
Allstudents<-unique(data_clean$ID)


#save unformatted process data and item response data
saveRDS(data_clean,"data_clean unformatted process data.rds")
saveRDS(responsedata,"item responses.rds")

#same people
identical(unique(data_clean$ID),responsedata$ID)

#####Generate Phantom Items#####
#####Unigrams (apart from Start,End) (13)#####
p<-3760
city_subway<-rep(0,p)
country_trains<-rep(0,p)
full_fare<-rep(0,p)
concession<-rep(0,p)
daily<-rep(0,p)
individual<-rep(0,p)
trip1<-rep(0,p)
trip2<-rep(0,p)
trip3<-rep(0,p)
trip4<-rep(0,p)
trip5<-rep(0,p)
cancel<-rep(0,p)
buy<-rep(0,p)
for (i in 1:p){
  USA01_stu<-data_clean[which(data_clean$ID==Allstudents[i]),]
  city_subway[i]<-sum(USA01_stu$event_value=="city_subway")
  country_trains[i]<-sum(USA01_stu$event_value=="country_trains")
  full_fare[i]<-sum(USA01_stu$event_value=="full_fare")
  concession[i]<-sum(USA01_stu$event_value=="concession")
  daily[i]<-sum(USA01_stu$event_value=="daily")
  individual[i]<-sum(USA01_stu$event_value=="individual")
  trip1[i]<-sum(USA01_stu$event_value=="trip_1")
  trip2[i]<-sum(USA01_stu$event_value=="trip_2")
  trip3[i]<-sum(USA01_stu$event_value=="trip_3")
  trip4[i]<-sum(USA01_stu$event_value=="trip_4")
  trip5[i]<-sum(USA01_stu$event_value=="trip_5")
  cancel[i]<-sum(USA01_stu$event_value=="Cancel")
  buy[i]<-sum(USA01_stu$event_value=="Buy")
}

#####Bi-grams (53)#####
S_city<-rep(0,p)
S_country<-rep(0,p)
city_full<-rep(0,p)
city_concession<-rep(0,p)
city_cancel<-rep(0,p)
country_full<-rep(0,p)
country_concession<-rep(0,p)
country_cancel<-rep(0,p)
concession_daily<-rep(0,p)
concession_individual<-rep(0,p)

concession_cancel<-rep(0,p)
full_daily<-rep(0,p)
full_individual<-rep(0,p)
full_cancel<-rep(0,p)
individual_trip1<-rep(0,p)
individual_trip2<-rep(0,p)
individual_trip3<-rep(0,p)
individual_trip4<-rep(0,p)
individual_trip5<-rep(0,p)
individual_cancel<-rep(0,p)

individual_buy<-rep(0,p)
trip1_cancel<-rep(0,p)
trip2_cancel<-rep(0,p)
trip3_cancel<-rep(0,p)
trip4_cancel<-rep(0,p)
trip5_cancel<-rep(0,p)
daily_cancel<-rep(0,p)
daily_buy<-rep(0,p)
trip1_buy<-rep(0,p)
trip2_buy<-rep(0,p)

trip3_buy<-rep(0,p)
trip4_buy<-rep(0,p)
trip5_buy<-rep(0,p)
trip1_trip2<-rep(0,p)
trip1_trip3<-rep(0,p)
trip1_trip4<-rep(0,p)
trip1_trip5<-rep(0,p)
trip2_trip1<-rep(0,p)
trip2_trip3<-rep(0,p)
trip2_trip4<-rep(0,p)

trip2_trip5<-rep(0,p)
trip3_trip1<-rep(0,p)
trip3_trip2<-rep(0,p)
trip3_trip4<-rep(0,p)
trip3_trip5<-rep(0,p)
trip4_trip1<-rep(0,p)
trip4_trip2<-rep(0,p)
trip4_trip3<-rep(0,p)
trip4_trip5<-rep(0,p)
trip5_trip1<-rep(0,p)

trip5_trip2<-rep(0,p)
trip5_trip3<-rep(0,p)
trip5_trip4<-rep(0,p)

for (i in 1:p){
  USA01_stu<-data_clean[which(data_clean$ID==Allstudents[i]),]
  S_city[i]<-sum(USA01_stu$event_value[2]=="city_subway")
  S_country[i]<-sum(USA01_stu$event_value[2]=="country_trains")
  n<-length(USA01_stu$event_value)
  trip4_buy[i]<- sum(USA01_stu$event_value[n-2]=="trip_4"&USA01_stu$event_value[n-1]=="Buy")
  trip1_buy[i]<- sum(USA01_stu$event_value[n-2]=="trip_1"&USA01_stu$event_value[n-1]=="Buy")
  trip2_buy[i]<- sum(USA01_stu$event_value[n-2]=="trip_2"&USA01_stu$event_value[n-1]=="Buy")
  trip3_buy[i]<- sum(USA01_stu$event_value[n-2]=="trip_3"&USA01_stu$event_value[n-1]=="Buy")
  trip5_buy[i]<- sum(USA01_stu$event_value[n-2]=="trip_5"&USA01_stu$event_value[n-1]=="Buy")
  daily_buy[i]<-sum(USA01_stu$event_value[n-2]=="daily"&USA01_stu$event_value[n-1]=="Buy")
  individual_buy[i]<-sum(USA01_stu$event_value[n-2]=="individual"&USA01_stu$event_value[n-1]=="Buy")

  for (j in 1:n){
    if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="full_fare")
      city_full[i]<-city_full[i]+1
    if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="concession")
      city_concession[i]<-city_concession[i]+1
     if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="Cancel")
      city_cancel[i]<-city_cancel[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="full_fare")
      country_full[i]<-country_full[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="concession")
      country_concession[i]<-country_concession[i]+1
   if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="Cancel")
      country_cancel[i]<-country_cancel[i]+1
    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="daily")
      concession_daily[i]<-concession_daily[i]+1
    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual")
      concession_individual[i]<-concession_individual[i]+1
    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="Cancel")
     concession_cancel[i]<-concession_cancel[i]+1
    if (USA01_stu$event_value[j]=="full_fare"&USA01_stu$event_value[j+1]=="daily")
      full_daily[i]<-full_daily[i]+1
    if (USA01_stu$event_value[j]=="full_fare"&USA01_stu$event_value[j+1]=="individual")
      full_individual[i]<-full_individual[i]+1

   if (USA01_stu$event_value[j]=="full_fare"&USA01_stu$event_value[j+1]=="Cancel")
      full_cancel[i]<-full_cancel[i]+1
    if (USA01_stu$event_value[j]=="individual"&USA01_stu$event_value[j+1]=="trip_4")
      individual_trip4[i]<-individual_trip4[i]+1
    if (USA01_stu$event_value[j]=="individual"&USA01_stu$event_value[j+1]=="trip_1")
      individual_trip1[i]<-individual_trip1[i]+1
    if (USA01_stu$event_value[j]=="individual"&USA01_stu$event_value[j+1]=="trip_2")
      individual_trip2[i]<-individual_trip2[i]+1
    if (USA01_stu$event_value[j]=="individual"&USA01_stu$event_value[j+1]=="trip_3")
      individual_trip3[i]<-individual_trip3[i]+1
    if (USA01_stu$event_value[j]=="individual"&USA01_stu$event_value[j+1]=="trip_5")
      individual_trip5[i]<-individual_trip5[i]+1
    if (USA01_stu$event_value[j]=="individual"&USA01_stu$event_value[j+1]=="Cancel")
     individual_cancel[i]<-individual_cancel[i]+1
    }
  for (j in 2:n){
    if (USA01_stu$event_value[j]=="Cancel"&USA01_stu$event_value[j-1]=="trip_1")
      trip1_cancel[i]<-trip1_cancel[i]+1
    if (USA01_stu$event_value[j]=="Cancel"&USA01_stu$event_value[j-1]=="trip_2")
      trip2_cancel[i]<-trip2_cancel[i]+1
    if (USA01_stu$event_value[j]=="Cancel"&USA01_stu$event_value[j-1]=="trip_3")
      trip3_cancel[i]<-trip3_cancel[i]+1
    if (USA01_stu$event_value[j]=="Cancel"&USA01_stu$event_value[j-1]=="trip_4")
      trip4_cancel[i]<-trip4_cancel[i]+1
    if (USA01_stu$event_value[j]=="Cancel"&USA01_stu$event_value[j-1]=="trip_5")
      trip5_cancel[i]<-trip5_cancel[i]+1
    if (USA01_stu$event_value[j]=="Cancel"&USA01_stu$event_value[j-1]=="daily")
      daily_cancel[i]<-daily_cancel[i]+1

    if (USA01_stu$event_value[j]=="trip_2"&USA01_stu$event_value[j-1]=="trip_1")
      trip1_trip2[i]<-trip1_trip2[i]+1
    if (USA01_stu$event_value[j]=="trip_3"&USA01_stu$event_value[j-1]=="trip_1")
      trip1_trip3[i]<-trip1_trip3[i]+1
    if (USA01_stu$event_value[j]=="trip_4"&USA01_stu$event_value[j-1]=="trip_1")
      trip1_trip4[i]<-trip1_trip4[i]+1
    if (USA01_stu$event_value[j]=="trip_5"&USA01_stu$event_value[j-1]=="trip_1")
      trip1_trip5[i]<-trip1_trip5[i]+1

    if (USA01_stu$event_value[j]=="trip_1"&USA01_stu$event_value[j-1]=="trip_2")
      trip2_trip1[i]<-trip2_trip1[i]+1
    if (USA01_stu$event_value[j]=="trip_3"&USA01_stu$event_value[j-1]=="trip_2")
      trip2_trip3[i]<-trip2_trip3[i]+1
    if (USA01_stu$event_value[j]=="trip_4"&USA01_stu$event_value[j-1]=="trip_2")
      trip2_trip4[i]<-trip2_trip4[i]+1
    if (USA01_stu$event_value[j]=="trip_5"&USA01_stu$event_value[j-1]=="trip_2")
      trip2_trip5[i]<-trip2_trip5[i]+1

    if (USA01_stu$event_value[j]=="trip_1"&USA01_stu$event_value[j-1]=="trip_3")
      trip3_trip1[i]<-trip3_trip1[i]+1
    if (USA01_stu$event_value[j]=="trip_2"&USA01_stu$event_value[j-1]=="trip_3")
      trip3_trip2[i]<-trip3_trip2[i]+1
    if (USA01_stu$event_value[j]=="trip_4"&USA01_stu$event_value[j-1]=="trip_3")
      trip3_trip4[i]<-trip3_trip4[i]+1
    if (USA01_stu$event_value[j]=="trip_5"&USA01_stu$event_value[j-1]=="trip_3")
      trip3_trip5[i]<-trip3_trip5[i]+1

    if (USA01_stu$event_value[j]=="trip_1"&USA01_stu$event_value[j-1]=="trip_4")
      trip4_trip1[i]<-trip4_trip1[i]+1
    if (USA01_stu$event_value[j]=="trip_2"&USA01_stu$event_value[j-1]=="trip_4")
      trip4_trip2[i]<-trip4_trip2[i]+1
    if (USA01_stu$event_value[j]=="trip_3"&USA01_stu$event_value[j-1]=="trip_4")
      trip4_trip3[i]<-trip4_trip3[i]+1
    if (USA01_stu$event_value[j]=="trip_5"&USA01_stu$event_value[j-1]=="trip_4")
      trip4_trip5[i]<-trip4_trip5[i]+1

    if (USA01_stu$event_value[j]=="trip_1"&USA01_stu$event_value[j-1]=="trip_5")
      trip5_trip1[i]<-trip5_trip1[i]+1
    if (USA01_stu$event_value[j]=="trip_2"&USA01_stu$event_value[j-1]=="trip_5")
      trip5_trip2[i]<-trip5_trip2[i]+1
    if (USA01_stu$event_value[j]=="trip_3"&USA01_stu$event_value[j-1]=="trip_5")
      trip5_trip3[i]<-trip5_trip3[i]+1
    if (USA01_stu$event_value[j]=="trip_4"&USA01_stu$event_value[j-1]=="trip_5")
      trip5_trip4[i]<-trip5_trip4[i]+1
  }
}

#####Tri-grams (52)#####
city_con_daily<-rep(0,p)
city_con_ind<-rep(0,p)
city_con_cancel<-rep(0,p)
city_full_daily<-rep(0,p)
city_full_ind<-rep(0,p)
city_full_cancel<-rep(0,p)
country_con_daily<-rep(0,p)
country_con_ind<-rep(0,p)
country_con_cancel<-rep(0,p)
country_full_daily<-rep(0,p)

country_full_ind<-rep(0,p)
country_full_cancel<-rep(0,p)
full_daily_buy<-rep(0,p)
full_daily_cancel<-rep(0,p)
full_individual_trip1<-rep(0,p)
full_individual_trip2<-rep(0,p)
full_individual_trip3<-rep(0,p)
full_individual_trip4<-rep(0,p)
full_individual_trip5<-rep(0,p)
full_individual_cancel<-rep(0,p)

full_individual_buy<-rep(0,p)
con_daily_buy<-rep(0,p)
con_daily_cancel<-rep(0,p)
con_individual_trip1<-rep(0,p)
con_individual_trip2<-rep(0,p)
con_individual_trip3<-rep(0,p)
con_individual_trip4<-rep(0,p)
con_individual_trip5<-rep(0,p)
con_individual_cancel<-rep(0,p)
con_individual_buy<-rep(0,p)

ind_trip1_trip2<-rep(0,p)
ind_trip1_trip3<-rep(0,p)
ind_trip1_trip4<-rep(0,p)
ind_trip1_trip5<-rep(0,p)
ind_trip2_trip1<-rep(0,p)
ind_trip2_trip3<-rep(0,p)
ind_trip2_trip4<-rep(0,p)
ind_trip2_trip5<-rep(0,p)
ind_trip3_trip1<-rep(0,p)
ind_trip3_trip2<-rep(0,p)

ind_trip3_trip4<-rep(0,p)
ind_trip3_trip5<-rep(0,p)
ind_trip4_trip1<-rep(0,p)
ind_trip4_trip2<-rep(0,p)
ind_trip4_trip3<-rep(0,p)
ind_trip4_trip5<-rep(0,p)
ind_trip5_trip1<-rep(0,p)
ind_trip5_trip2<-rep(0,p)
ind_trip5_trip3<-rep(0,p)
ind_trip5_trip4<-rep(0,p)

ind_trip4_cancel<-rep(0,p)
ind_trip4_buy<-rep(0,p)
#action sequence started from individual should be the same as bi-gram situation
for (i in 1:p){
  USA01_stu<-data_clean[which(data_clean$ID==Allstudents[i]),]
  n<-length(USA01_stu$event_value)
  for (j in 1:n){
    if (USA01_stu$event_value[j]=="city_subway"& USA01_stu$event_value[j+1]=="concession"
        & USA01_stu$event_value[j+2]=="daily")
    city_con_daily[i]<-city_con_daily[i]+1
    if (USA01_stu$event_value[j]=="city_subway"& USA01_stu$event_value[j+1]=="concession"
        & USA01_stu$event_value[j+2]=="individual")
      city_con_ind[i]<-city_con_ind[i]+1
    if (USA01_stu$event_value[j]=="city_subway"& USA01_stu$event_value[j+1]=="concession"
        & USA01_stu$event_value[j+2]=="Cancel")
      city_con_cancel[i]<-city_con_cancel[i]+1
    if (USA01_stu$event_value[j]=="city_subway"& USA01_stu$event_value[j+1]=="full_fare"
        & USA01_stu$event_value[j+2]=="daily")
      city_full_daily[i]<-city_full_daily[i]+1
    if (USA01_stu$event_value[j]=="city_subway"& USA01_stu$event_value[j+1]=="full_fare"
        & USA01_stu$event_value[j+2]=="individual")
      city_full_ind[i]<-city_full_ind[i]+1
    if (USA01_stu$event_value[j]=="city_subway"& USA01_stu$event_value[j+1]=="full_fare"
        & USA01_stu$event_value[j+2]=="Cancel")
      city_full_cancel[i]<-city_full_cancel[i]+1
    if (USA01_stu$event_value[j]=="country_trains"& USA01_stu$event_value[j+1]=="concession"
        & USA01_stu$event_value[j+2]=="daily")
    country_con_daily[i]<-country_con_daily[i]+1
    if (USA01_stu$event_value[j]=="country_trains"& USA01_stu$event_value[j+1]=="concession"
        & USA01_stu$event_value[j+2]=="individual")
      country_con_ind[i]<-country_con_ind[i]+1
    if (USA01_stu$event_value[j]=="country_trains"& USA01_stu$event_value[j+1]=="concession"
        & USA01_stu$event_value[j+2]=="Cancel")
      country_con_cancel[i]<-country_con_cancel[i]+1
    if (USA01_stu$event_value[j]=="country_trains"& USA01_stu$event_value[j+1]=="full_fare"
        & USA01_stu$event_value[j+2]=="daily")
      country_full_daily[i]<-country_full_daily[i]+1

    if (USA01_stu$event_value[j]=="country_trains"& USA01_stu$event_value[j+1]=="full_fare"
        & USA01_stu$event_value[j+2]=="individual")
      country_full_ind[i]<-country_full_ind[i]+1
    if (USA01_stu$event_value[j]=="country_trains"& USA01_stu$event_value[j+1]=="full_fare"
        & USA01_stu$event_value[j+2]=="Cancel")
      country_full_cancel[i]<-country_full_cancel[i]+1
    if (USA01_stu$event_value[j]=="full_fare"& USA01_stu$event_value[j+1]=="daily"
        & USA01_stu$event_value[j+2]=="Buy")
      full_daily_buy[i]<-full_daily_buy[i]+1
    if (USA01_stu$event_value[j]=="full_fare"& USA01_stu$event_value[j+1]=="daily"
        & USA01_stu$event_value[j+2]=="Cancel")
      full_daily_cancel[i]<-full_daily_cancel[i]+1
    if (USA01_stu$event_value[j]=="full_fare"& USA01_stu$event_value[j+1]=="individual"
        & USA01_stu$event_value[j+2]=="trip_1")
      full_individual_trip1[i]<-full_individual_trip1[i]+1
    if (USA01_stu$event_value[j]=="full_fare"& USA01_stu$event_value[j+1]=="individual"
        & USA01_stu$event_value[j+2]=="trip_2")
      full_individual_trip2[i]<-full_individual_trip2[i]+1
    if (USA01_stu$event_value[j]=="full_fare"& USA01_stu$event_value[j+1]=="individual"
        & USA01_stu$event_value[j+2]=="trip_3")
      full_individual_trip3[i]<-full_individual_trip3[i]+1
    if (USA01_stu$event_value[j]=="full_fare"& USA01_stu$event_value[j+1]=="individual"
        & USA01_stu$event_value[j+2]=="trip_4")
      full_individual_trip4[i]<-full_individual_trip4[i]+1
    if (USA01_stu$event_value[j]=="full_fare"& USA01_stu$event_value[j+1]=="individual"
        & USA01_stu$event_value[j+2]=="trip_5")
      full_individual_trip5[i]<-full_individual_trip5[i]+1
    if (USA01_stu$event_value[j]=="full_fare"& USA01_stu$event_value[j+1]=="individual"
        & USA01_stu$event_value[j+2]=="Cancel")
      full_individual_cancel[i]<-full_individual_cancel[i]+1

    if (USA01_stu$event_value[j]=="full_fare" & USA01_stu$event_value[j+1]=="individual"
        & USA01_stu$event_value[j+2]=="Buy")
      full_individual_buy[i]<-full_individual_buy[i]+1
    if (USA01_stu$event_value[j]=="concession"& USA01_stu$event_value[j+1]=="daily"
        & USA01_stu$event_value[j+2]=="Buy")
      con_daily_buy[i]<-con_daily_buy[i]+1
    if (USA01_stu$event_value[j]=="concession"& USA01_stu$event_value[j+1]=="daily"
        & USA01_stu$event_value[j+2]=="Cancel")
      con_daily_cancel[i]<-con_daily_cancel[i]+1
    if (USA01_stu$event_value[j]=="concession"& USA01_stu$event_value[j+1]=="individual"
        & USA01_stu$event_value[j+2]=="trip_1")
      con_individual_trip1[i]<-con_individual_trip1[i]+1
    if (USA01_stu$event_value[j]=="concession"& USA01_stu$event_value[j+1]=="individual"
        & USA01_stu$event_value[j+2]=="trip_2")
      con_individual_trip2[i]<-con_individual_trip2[i]+1
    if (USA01_stu$event_value[j]=="concession"& USA01_stu$event_value[j+1]=="individual"
        & USA01_stu$event_value[j+2]=="trip_3")
      con_individual_trip3[i]<-con_individual_trip3[i]+1
    if (USA01_stu$event_value[j]=="concession"& USA01_stu$event_value[j+1]=="individual"
        & USA01_stu$event_value[j+2]=="trip_4")
      con_individual_trip4[i]<-con_individual_trip4[i]+1
    if (USA01_stu$event_value[j]=="concession"& USA01_stu$event_value[j+1]=="individual"
        & USA01_stu$event_value[j+2]=="trip_5")
      con_individual_trip5[i]<-con_individual_trip5[i]+1
    if (USA01_stu$event_value[j]=="concession"& USA01_stu$event_value[j+1]=="individual"
        & USA01_stu$event_value[j+2]=="Cancel")
      con_individual_cancel[i]<-con_individual_cancel[i]+1
    if (USA01_stu$event_value[j]=="concession" & USA01_stu$event_value[j+1]=="individual"
        & USA01_stu$event_value[j+2]=="Buy")
      con_individual_buy[i]<-con_individual_buy[i]+1

    if (USA01_stu$event_value[j]=="individual"& USA01_stu$event_value[j+1]=="trip_1"
        & USA01_stu$event_value[j+2]=="trip_2")
      ind_trip1_trip2[i]<-ind_trip1_trip2[i]+1
    if (USA01_stu$event_value[j]=="individual"& USA01_stu$event_value[j+1]=="trip_1"
        & USA01_stu$event_value[j+2]=="trip_3")
      ind_trip1_trip3[i]<-ind_trip1_trip3[i]+1
    if (USA01_stu$event_value[j]=="individual"& USA01_stu$event_value[j+1]=="trip_1"
        & USA01_stu$event_value[j+2]=="trip_4")
      ind_trip1_trip4[i]<-ind_trip1_trip4[i]+1
    if (USA01_stu$event_value[j]=="individual" & USA01_stu$event_value[j+1]=="trip_1"
        & USA01_stu$event_value[j+2]=="trip_5")
      ind_trip1_trip5[i]<-ind_trip1_trip5[i]+1

    if (USA01_stu$event_value[j]=="individual"& USA01_stu$event_value[j+1]=="trip_2"
        & USA01_stu$event_value[j+2]=="trip_1")
      ind_trip2_trip1[i]<-ind_trip2_trip1[i]+1
    if (USA01_stu$event_value[j]=="individual"& USA01_stu$event_value[j+1]=="trip_2"
        & USA01_stu$event_value[j+2]=="trip_3")
      ind_trip2_trip3[i]<-ind_trip2_trip3[i]+1
    if (USA01_stu$event_value[j]=="individual"& USA01_stu$event_value[j+1]=="trip_2"
        & USA01_stu$event_value[j+2]=="trip_4")
      ind_trip2_trip4[i]<-ind_trip2_trip4[i]+1
    if (USA01_stu$event_value[j]=="individual" & USA01_stu$event_value[j+1]=="trip_2"
        & USA01_stu$event_value[j+2]=="trip_5")
      ind_trip2_trip5[i]<-ind_trip2_trip5[i]+1

    if (USA01_stu$event_value[j]=="individual"& USA01_stu$event_value[j+1]=="trip_3"
        & USA01_stu$event_value[j+2]=="trip_1")
      ind_trip1_trip2[i]<-ind_trip1_trip2[i]+1
    if (USA01_stu$event_value[j]=="individual"& USA01_stu$event_value[j+1]=="trip_3"
        & USA01_stu$event_value[j+2]=="trip_2")
      ind_trip1_trip3[i]<-ind_trip1_trip3[i]+1
    if (USA01_stu$event_value[j]=="individual"& USA01_stu$event_value[j+1]=="trip_3"
        & USA01_stu$event_value[j+2]=="trip_4")
      ind_trip1_trip4[i]<-ind_trip1_trip4[i]+1
    if (USA01_stu$event_value[j]=="individual" & USA01_stu$event_value[j+1]=="trip_3"
        & USA01_stu$event_value[j+2]=="trip_5")
      ind_trip1_trip5[i]<-ind_trip1_trip5[i]+1

    if (USA01_stu$event_value[j]=="individual"& USA01_stu$event_value[j+1]=="trip_4"
        & USA01_stu$event_value[j+2]=="trip_1")
      ind_trip4_trip1[i]<-ind_trip4_trip1[i]+1
    if (USA01_stu$event_value[j]=="individual"& USA01_stu$event_value[j+1]=="trip_4"
        & USA01_stu$event_value[j+2]=="trip_2")
      ind_trip4_trip2[i]<-ind_trip4_trip2[i]+1
    if (USA01_stu$event_value[j]=="individual"& USA01_stu$event_value[j+1]=="trip_4"
        & USA01_stu$event_value[j+2]=="trip_3")
      ind_trip4_trip3[i]<-ind_trip4_trip3[i]+1
    if (USA01_stu$event_value[j]=="individual" & USA01_stu$event_value[j+1]=="trip_4"
        & USA01_stu$event_value[j+2]=="trip_5")
      ind_trip4_trip5[i]<-ind_trip4_trip5[i]+1

    if (USA01_stu$event_value[j]=="individual"& USA01_stu$event_value[j+1]=="trip_5"
        & USA01_stu$event_value[j+2]=="trip_1")
      ind_trip5_trip1[i]<-ind_trip5_trip1[i]+1
    if (USA01_stu$event_value[j]=="individual"& USA01_stu$event_value[j+1]=="trip_5"
        & USA01_stu$event_value[j+2]=="trip_2")
      ind_trip5_trip2[i]<-ind_trip5_trip2[i]+1
    if (USA01_stu$event_value[j]=="individual"& USA01_stu$event_value[j+1]=="trip_5"
        & USA01_stu$event_value[j+2]=="trip_3")
      ind_trip5_trip3[i]<-ind_trip5_trip3[i]+1
    if (USA01_stu$event_value[j]=="individual" & USA01_stu$event_value[j+1]=="trip_5"
        & USA01_stu$event_value[j+2]=="trip_4")
      ind_trip5_trip4[i]<-ind_trip5_trip4[i]+1

    if (USA01_stu$event_value[j]=="individual" & USA01_stu$event_value[j+1]=="trip_4"
        & USA01_stu$event_value[j+2]=="Cancel")
      ind_trip4_cancel[i]<-ind_trip4_cancel[i]+1
    if (USA01_stu$event_value[j]=="individual" & USA01_stu$event_value[j+1]=="trip_4"
        & USA01_stu$event_value[j+2]=="Buy")
      ind_trip4_buy[i]<-ind_trip4_buy[i]+1
  }
}

#####Four-grams (78)#####
city_con_daily_cancel<-rep(0,p)
city_con_daily_buy<-rep(0,p)
city_full_daily_cancel<-rep(0,p)
city_full_daily_buy<-rep(0,p)
city_con_ind_cancel<-rep(0,p)
city_con_ind_buy<-rep(0,p)
city_full_ind_cancel<-rep(0,p)
city_full_ind_buy<-rep(0,p)
city_con_ind_trip1<-rep(0,p)
city_con_ind_trip2<-rep(0,p)

city_con_ind_trip3<-rep(0,p)
city_con_ind_trip4<-rep(0,p)
city_con_ind_trip5<-rep(0,p)
city_full_ind_trip1<-rep(0,p)
city_full_ind_trip2<-rep(0,p)
city_full_ind_trip3<-rep(0,p)
city_full_ind_trip4<-rep(0,p)
city_full_ind_trip5<-rep(0,p)
country_con_daily_cancel<-rep(0,p)
country_con_daily_buy<-rep(0,p)

country_full_daily_cancel<-rep(0,p)
country_full_daily_buy<-rep(0,p)
country_con_ind_cancel<-rep(0,p)
country_con_ind_buy<-rep(0,p)
country_full_ind_cancel<-rep(0,p)
country_full_ind_buy<-rep(0,p)
country_con_ind_trip1<-rep(0,p)
country_con_ind_trip2<-rep(0,p)
country_con_ind_trip3<-rep(0,p)
country_con_ind_trip4<-rep(0,p)

country_con_ind_trip5<-rep(0,p)
country_full_ind_trip1<-rep(0,p)
country_full_ind_trip2<-rep(0,p)
country_full_ind_trip3<-rep(0,p)
country_full_ind_trip4<-rep(0,p)
country_full_ind_trip5<-rep(0,p)
full_ind_trip1_trip2<-rep(0,p)
full_ind_trip1_trip3<-rep(0,p)
full_ind_trip1_trip4<-rep(0,p)
full_ind_trip1_trip5<-rep(0,p)

full_ind_trip2_trip1<-rep(0,p)
full_ind_trip2_trip3<-rep(0,p)
full_ind_trip2_trip4<-rep(0,p)
full_ind_trip2_trip5<-rep(0,p)
full_ind_trip3_trip1<-rep(0,p)
full_ind_trip3_trip2<-rep(0,p)
full_ind_trip3_trip4<-rep(0,p)
full_ind_trip3_trip5<-rep(0,p)
full_ind_trip4_trip1<-rep(0,p)
full_ind_trip4_trip2<-rep(0,p)

full_ind_trip4_trip3<-rep(0,p)
full_ind_trip4_trip5<-rep(0,p)
full_ind_trip5_trip1<-rep(0,p)
full_ind_trip5_trip3<-rep(0,p)
full_ind_trip5_trip4<-rep(0,p)
full_ind_trip5_trip2<-rep(0,p)
con_ind_trip1_trip2<-rep(0,p)
con_ind_trip1_trip3<-rep(0,p)
con_ind_trip1_trip4<-rep(0,p)
con_ind_trip1_trip5<-rep(0,p)

con_ind_trip2_trip1<-rep(0,p)
con_ind_trip2_trip3<-rep(0,p)
con_ind_trip2_trip4<-rep(0,p)
con_ind_trip2_trip5<-rep(0,p)
con_ind_trip3_trip1<-rep(0,p)
con_ind_trip3_trip2<-rep(0,p)
con_ind_trip3_trip4<-rep(0,p)
con_ind_trip3_trip5<-rep(0,p)
con_ind_trip4_trip1<-rep(0,p)
con_ind_trip4_trip2<-rep(0,p)

con_ind_trip4_trip3<-rep(0,p)
con_ind_trip4_trip5<-rep(0,p)
con_ind_trip5_trip1<-rep(0,p)
con_ind_trip5_trip3<-rep(0,p)
con_ind_trip5_trip4<-rep(0,p)
con_ind_trip5_trip2<-rep(0,p)
con_ind_trip4_cancel<-rep(0,p)
con_ind_trip4_buy<-rep(0,p)

for (i in 1:p){
  USA01_stu<-data_clean[which(data_clean$ID==Allstudents[i]),]
  n<-length(USA01_stu$event_value)
  for (j in 1:n){
    if (USA01_stu$event_value[j]=="city_subway"& USA01_stu$event_value[j+1]=="concession"
        & USA01_stu$event_value[j+2]=="daily"& USA01_stu$event_value[j+3]=="Cancel")
      city_con_daily_cancel[i]<-city_con_daily_cancel[i]+1
    if (USA01_stu$event_value[j]=="city_subway"& USA01_stu$event_value[j+1]=="concession"
        & USA01_stu$event_value[j+2]=="daily"& USA01_stu$event_value[j+3]=="Buy")
      city_con_daily_buy[i]<-city_con_daily_buy[i]+1
    if (USA01_stu$event_value[j]=="city_subway"& USA01_stu$event_value[j+1]=="full_fare"
        & USA01_stu$event_value[j+2]=="daily"& USA01_stu$event_value[j+3]=="Buy")
      city_full_daily_buy[i]<-city_full_daily_buy[i]+1
    if (USA01_stu$event_value[j]=="city_subway"& USA01_stu$event_value[j+1]=="full_fare"
        & USA01_stu$event_value[j+2]=="daily"& USA01_stu$event_value[j+3]=="Cancel")
      city_full_daily_cancel[i]<-city_full_daily_cancel[i]+1

    if (USA01_stu$event_value[j]=="city_subway"& USA01_stu$event_value[j+1]=="concession"
        & USA01_stu$event_value[j+2]=="individual"& USA01_stu$event_value[j+3]=="Cancel")
      city_con_ind_cancel[i]<-city_con_ind_cancel[i]+1
    if (USA01_stu$event_value[j]=="city_subway"& USA01_stu$event_value[j+1]=="concession"
        & USA01_stu$event_value[j+2]=="individual"& USA01_stu$event_value[j+3]=="Buy")
      city_con_ind_buy[i]<-city_con_ind_buy[i]+1
    if (USA01_stu$event_value[j]=="city_subway"& USA01_stu$event_value[j+1]=="full_fare"
        & USA01_stu$event_value[j+2]=="individual"& USA01_stu$event_value[j+3]=="Buy")
      city_full_ind_buy[i]<-city_full_ind_buy[i]+1
    if (USA01_stu$event_value[j]=="city_subway"& USA01_stu$event_value[j+1]=="full_fare"
        & USA01_stu$event_value[j+2]=="individual"& USA01_stu$event_value[j+3]=="Cancel")
      city_full_ind_cancel[i]<-city_full_ind_cancel[i]+1


    if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="full_fare"& USA01_stu$event_value[j+2]=="individual"
        & USA01_stu$event_value[j+3]=="trip_1")
      city_full_ind_trip1[i]<-city_full_ind_trip1[i]+1
    if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="full_fare"& USA01_stu$event_value[j+2]=="individual"
        & USA01_stu$event_value[j+3]=="trip_2")
      city_full_ind_trip2[i]<-city_full_ind_trip2[i]+1
    if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="full_fare"& USA01_stu$event_value[j+2]=="individual"
        & USA01_stu$event_value[j+3]=="trip_3")
      city_full_ind_trip3[i]<-city_full_ind_trip3[i]+1
    if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="full_fare"& USA01_stu$event_value[j+2]=="individual"
        & USA01_stu$event_value[j+3]=="trip_4")
      city_full_ind_trip4[i]<-city_full_ind_trip4[i]+1
    if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="full_fare"& USA01_stu$event_value[j+2]=="individual"
        & USA01_stu$event_value[j+3]=="trip_5")
      city_full_ind_trip5[i]<-city_full_ind_trip5[i]+1

    if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="concession"& USA01_stu$event_value[j+2]=="individual"
        & USA01_stu$event_value[j+3]=="trip_1")
      city_con_ind_trip1[i]<-city_con_ind_trip1[i]+1
    if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="concession"& USA01_stu$event_value[j+2]=="individual"
        & USA01_stu$event_value[j+3]=="trip_2")
      city_con_ind_trip2[i]<-city_con_ind_trip2[i]+1
    if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="concession"& USA01_stu$event_value[j+2]=="individual"
        & USA01_stu$event_value[j+3]=="trip_3")
      city_con_ind_trip3[i]<-city_con_ind_trip3[i]+1
    if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="concession"& USA01_stu$event_value[j+2]=="individual"
        & USA01_stu$event_value[j+3]=="trip_4")
      city_con_ind_trip4[i]<-city_con_ind_trip4[i]+1
    if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="concession"& USA01_stu$event_value[j+2]=="individual"
        & USA01_stu$event_value[j+3]=="trip_5")
      city_con_ind_trip5[i]<-city_con_ind_trip5[i]+1

    if (USA01_stu$event_value[j]=="country_trains"& USA01_stu$event_value[j+1]=="concession"
        & USA01_stu$event_value[j+2]=="daily" & USA01_stu$event_value[j+3]=="Cancel")
      country_con_daily_cancel[i]<-country_con_daily_cancel[i]+1
    if (USA01_stu$event_value[j]=="country_trains"& USA01_stu$event_value[j+1]=="concession"
        & USA01_stu$event_value[j+2]=="daily"& USA01_stu$event_value[j+3]=="Buy")
      country_con_daily_buy[i]<-country_con_daily_buy[i]+1
    if (USA01_stu$event_value[j]=="country_trains"& USA01_stu$event_value[j+1]=="full_fare"
        & USA01_stu$event_value[j+2]=="daily"& USA01_stu$event_value[j+3]=="Cancel")
      country_full_daily_cancel[i]<-country_full_daily_cancel[i]+1
    if (USA01_stu$event_value[j]=="country_trains"& USA01_stu$event_value[j+1]=="full_fare"
        & USA01_stu$event_value[j+2]=="daily"& USA01_stu$event_value[j+3]=="Buy")
      country_full_daily_buy[i]<-country_full_daily_buy[i]+1

    if (USA01_stu$event_value[j]=="country_trains"
        &USA01_stu$event_value[j+1]=="concession"
        & USA01_stu$event_value[j+2]=="individual" & USA01_stu$event_value[j+3]=="Cancel")
      country_con_ind_cancel[i]<-country_con_ind_cancel[i]+1
    if (USA01_stu$event_value[j]=="country_trains" & USA01_stu$event_value[j+1]=="concession"
        & USA01_stu$event_value[j+2]=="individual"& USA01_stu$event_value[j+3]=="Buy")
      country_con_ind_buy[i]<-country_con_ind_buy[i]+1
    if (USA01_stu$event_value[j]==" country_trains "& USA01_stu$event_value[j+1]=="full_fare"
        & USA01_stu$event_value[j+2]=="individual"& USA01_stu$event_value[j+3]=="Cancel")
      country_full_ind_cancel[i]<-country_full_ind_cancel[i]+1
    if (USA01_stu$event_value[j]==" country_trains "& USA01_stu$event_value[j+1]=="full_fare"
        & USA01_stu$event_value[j+2]=="individual"& USA01_stu$event_value[j+3]=="Buy")
      country_full_ind_buy[i]<-country_full_ind_buy[i]+1

    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="full_fare"& USA01_stu$event_value[j+2]=="individual"
        & USA01_stu$event_value[j+3]=="trip_1")
      country_full_ind_trip1[i]<-country_full_ind_trip1[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="full_fare"& USA01_stu$event_value[j+2]=="individual"
        & USA01_stu$event_value[j+3]=="trip_2")
      country_full_ind_trip2[i]<-country_full_ind_trip2[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="full_fare"& USA01_stu$event_value[j+2]=="individual"
        & USA01_stu$event_value[j+3]=="trip_3")
      country_full_ind_trip3[i]<-country_full_ind_trip3[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="full_fare"& USA01_stu$event_value[j+2]=="individual"
        & USA01_stu$event_value[j+3]=="trip_4")
      country_full_ind_trip4[i]<-country_full_ind_trip4[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="full_fare"& USA01_stu$event_value[j+2]=="individual"
        & USA01_stu$event_value[j+3]=="trip_5")
      country_full_ind_trip5[i]<-country_full_ind_trip5[i]+1

    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="concession"& USA01_stu$event_value[j+2]=="individual"
        & USA01_stu$event_value[j+3]=="trip_1")
      country_con_ind_trip1[i]<-country_con_ind_trip1[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="concession"& USA01_stu$event_value[j+2]=="individual"
        & USA01_stu$event_value[j+3]=="trip_2")
      country_con_ind_trip2[i]<-country_con_ind_trip2[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="concession"& USA01_stu$event_value[j+2]=="individual"
        & USA01_stu$event_value[j+3]=="trip_3")
      country_con_ind_trip3[i]<-country_con_ind_trip3[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="concession"& USA01_stu$event_value[j+2]=="individual"
        & USA01_stu$event_value[j+3]=="trip_4")
      country_con_ind_trip4[i]<-country_con_ind_trip4[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="concession"& USA01_stu$event_value[j+2]=="individual"
        & USA01_stu$event_value[j+3]=="trip_5")
      country_con_ind_trip5[i]<-country_con_ind_trip5[i]+1

    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_1"
        & USA01_stu$event_value[j+3]=="trip_2")
      con_ind_trip1_trip2[i]<-con_ind_trip1_trip2[i]+1
    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_1"
        & USA01_stu$event_value[j+3]=="trip_3")
      con_ind_trip1_trip3[i]<-con_ind_trip1_trip3[i]+1
    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_1"
        & USA01_stu$event_value[j+3]=="trip_4")
      con_ind_trip1_trip4[i]<-con_ind_trip1_trip4[i]+1
    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_1"
        & USA01_stu$event_value[j+3]=="trip_5")
      con_ind_trip1_trip5[i]<-con_ind_trip1_trip5[i]+1
    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_2"
        & USA01_stu$event_value[j+3]=="trip_1")
      con_ind_trip2_trip1[i]<-con_ind_trip2_trip1[i]+1

    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_2"
        & USA01_stu$event_value[j+3]=="trip_3")
      con_ind_trip2_trip3[i]<-con_ind_trip2_trip3[i]+1
    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_2"
        & USA01_stu$event_value[j+3]=="trip_4")
      con_ind_trip2_trip4[i]<-con_ind_trip2_trip4[i]+1
    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_2"
        & USA01_stu$event_value[j+3]=="trip_5")
      con_ind_trip2_trip5[i]<-con_ind_trip2_trip5[i]+1
    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_3"
        & USA01_stu$event_value[j+3]=="trip_1")
      con_ind_trip3_trip1[i]<-con_ind_trip3_trip1[i]+1
    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_3"
        & USA01_stu$event_value[j+3]=="trip_2")
      con_ind_trip3_trip2[i]<-con_ind_trip3_trip2[i]+1
    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_3"
        & USA01_stu$event_value[j+3]=="trip_4")
      con_ind_trip3_trip4[i]<-con_ind_trip3_trip4[i]+1
    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_3"
        & USA01_stu$event_value[j+3]=="trip_5")
      con_ind_trip3_trip5[i]<-con_ind_trip3_trip5[i]+1

    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_4"
        & USA01_stu$event_value[j+3]=="trip_1")
      con_ind_trip4_trip1[i]<-con_ind_trip4_trip1[i]+1
    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_4"
        & USA01_stu$event_value[j+3]=="trip_2")
      con_ind_trip4_trip2[i]<-con_ind_trip4_trip2[i]+1
    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_4"
        & USA01_stu$event_value[j+3]=="trip_3")
      con_ind_trip4_trip3[i]<-con_ind_trip4_trip3[i]+1
    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_4"
        & USA01_stu$event_value[j+3]=="trip_5")
      con_ind_trip4_trip5[i]<-con_ind_trip4_trip5[i]+1

    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_5"
        & USA01_stu$event_value[j+3]=="trip_1")
      con_ind_trip5_trip1[i]<-con_ind_trip5_trip1[i]+1
    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_5"
        & USA01_stu$event_value[j+3]=="trip_2")
      con_ind_trip5_trip2[i]<-con_ind_trip5_trip2[i]+1
    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_5"
        & USA01_stu$event_value[j+3]=="trip_3")
      con_ind_trip5_trip3[i]<-con_ind_trip5_trip3[i]+1
    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_5"
        & USA01_stu$event_value[j+3]=="trip_4")
      con_ind_trip5_trip4[i]<-con_ind_trip5_trip4[i]+1

    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_1"
        & USA01_stu$event_value[j+3]=="trip_2")
      country_ind_trip1_trip2[i]<-country_ind_trip1_trip2[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_1"
        & USA01_stu$event_value[j+3]=="trip_3")
      country_ind_trip1_trip3[i]<-country_ind_trip1_trip3[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_1"
        & USA01_stu$event_value[j+3]=="trip_4")
      country_ind_trip1_trip4[i]<-country_ind_trip1_trip4[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_1"
        & USA01_stu$event_value[j+3]=="trip_5")
      country_ind_trip1_trip5[i]<-country_ind_trip1_trip5[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_2"
        & USA01_stu$event_value[j+3]=="trip_1")
      country_ind_trip2_trip1[i]<-country_ind_trip2_trip1[i]+1

    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_2"
        & USA01_stu$event_value[j+3]=="trip_3")
      country_ind_trip2_trip3[i]<-country_ind_trip2_trip3[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_2"
        & USA01_stu$event_value[j+3]=="trip_4")
      country_ind_trip2_trip4[i]<-country_ind_trip2_trip4[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_2"
        & USA01_stu$event_value[j+3]=="trip_5")
      country_ind_trip2_trip5[i]<-country_ind_trip2_trip5[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_3"
        & USA01_stu$event_value[j+3]=="trip_1")
      country_ind_trip3_trip1[i]<-country_ind_trip3_trip1[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_3"
        & USA01_stu$event_value[j+3]=="trip_2")
      country_ind_trip3_trip2[i]<-country_ind_trip3_trip2[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_3"
        & USA01_stu$event_value[j+3]=="trip_4")
      country_ind_trip3_trip4[i]<-country_ind_trip3_trip4[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_3"
        & USA01_stu$event_value[j+3]=="trip_5")
      country_ind_trip3_trip5[i]<-country_ind_trip3_trip5[i]+1

    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_4"
        & USA01_stu$event_value[j+3]=="trip_1")
      country_ind_trip4_trip1[i]<-country_ind_trip4_trip1[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_4"
        & USA01_stu$event_value[j+3]=="trip_2")
      country_ind_trip4_trip2[i]<-country_ind_trip4_trip2[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_4"
        & USA01_stu$event_value[j+3]=="trip_3")
      country_ind_trip4_trip3[i]<-country_ind_trip4_trip3[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_4"
        & USA01_stu$event_value[j+3]=="trip_5")
      country_ind_trip4_trip5[i]<-country_ind_trip4_trip5[i]+1

    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_5"
        & USA01_stu$event_value[j+3]=="trip_1")
      country_ind_trip5_trip1[i]<-country_ind_trip5_trip1[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_5"
        & USA01_stu$event_value[j+3]=="trip_2")
      country_ind_trip5_trip2[i]<-country_ind_trip5_trip2[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_5"
        & USA01_stu$event_value[j+3]=="trip_3")
      country_ind_trip5_trip3[i]<-country_ind_trip5_trip3[i]+1
    if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_5"
        & USA01_stu$event_value[j+3]=="trip_4")
      country_ind_trip5_trip4[i]<-country_ind_trip5_trip4[i]+1

    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_4"
        & USA01_stu$event_value[j+3]=="Cancel")
      con_ind_trip4_cancel[i]<-con_ind_trip4_cancel[i]+1

    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual"& USA01_stu$event_value[j+2]=="trip_4"
        & USA01_stu$event_value[j+3]=="Buy")
      con_ind_trip4_buy[i]<-con_ind_trip4_buy[i]+1
  }
}

#####Five-grams (21)#####
city_con_ind_trip1_buy<-rep(0,p)
city_con_ind_trip2_buy<-rep(0,p)
city_con_ind_trip3_buy<-rep(0,p)
city_con_ind_trip4_buy<-rep(0,p)
city_con_ind_trip5_buy<-rep(0,p)
city_con_ind_trip4_cancel<-rep(0,p)
city_full_ind_trip1_buy<-rep(0,p)
city_full_ind_trip2_buy<-rep(0,p)
city_full_ind_trip3_buy<-rep(0,p)
city_full_ind_trip4_buy<-rep(0,p)

city_full_ind_trip5_buy<-rep(0,p)
country_con_ind_trip1_buy<-rep(0,p)
country_con_ind_trip2_buy<-rep(0,p)
country_con_ind_trip3_buy<-rep(0,p)
country_con_ind_trip4_buy<-rep(0,p)
country_con_ind_trip5_buy<-rep(0,p)
country_full_ind_trip1_buy<-rep(0,p)
country_full_ind_trip2_buy<-rep(0,p)
country_full_ind_trip3_buy<-rep(0,p)
country_full_ind_trip4_buy<-rep(0,p)

country_full_ind_trip5_buy<-rep(0,p)
for (i in 1:p){
  USA01_stu<-data_clean[which(data_clean$ID==Allstudents[i]),]
  n<-length(USA01_stu$event_value)
  for (j in 1:n){
if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="full_fare"& USA01_stu$event_value[j+2]=="individual"
    & USA01_stu$event_value[j+3]=="trip_1"& USA01_stu$event_value[j+4]=="Buy")
  city_full_ind_trip1_buy[i]<-city_full_ind_trip1_buy[i]+1
if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="full_fare"& USA01_stu$event_value[j+2]=="individual"
    & USA01_stu$event_value[j+3]=="trip_2"& USA01_stu$event_value[j+4]=="Buy")
  city_full_ind_trip2_buy[i]<-city_full_ind_trip2_buy[i]+1
if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="full_fare"& USA01_stu$event_value[j+2]=="individual"
    & USA01_stu$event_value[j+3]=="trip_3"& USA01_stu$event_value[j+4]=="Buy")
  city_full_ind_trip3_buy[i]<-city_full_ind_trip3_buy[i]+1
if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="full_fare"& USA01_stu$event_value[j+2]=="individual"
    & USA01_stu$event_value[j+3]=="trip_4"& USA01_stu$event_value[j+4]=="Buy")
  city_full_ind_trip4_buy[i]<-city_full_ind_trip4_buy[i]+1
if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="full_fare"& USA01_stu$event_value[j+2]=="individual"
    & USA01_stu$event_value[j+3]=="trip_5"& USA01_stu$event_value[j+4]=="Buy")
  city_full_ind_trip5_buy[i]<-city_full_ind_trip5_buy[i]+1

if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="concession"& USA01_stu$event_value[j+2]=="individual"
    & USA01_stu$event_value[j+3]=="trip_1"& USA01_stu$event_value[j+4]=="Buy")
  city_con_ind_trip1_buy[i]<-city_con_ind_trip1_buy[i]+1
if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="concession"& USA01_stu$event_value[j+2]=="individual"
    & USA01_stu$event_value[j+3]=="trip_2"& USA01_stu$event_value[j+4]=="Buy")
  city_con_ind_trip2_buy[i]<-city_con_ind_trip2_buy[i]+1
if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="concession"& USA01_stu$event_value[j+2]=="individual"
    & USA01_stu$event_value[j+3]=="trip_3"& USA01_stu$event_value[j+4]=="Buy")
  city_con_ind_trip3_buy[i]<-city_con_ind_trip3_buy[i]+1
if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="concession"& USA01_stu$event_value[j+2]=="individual"
    & USA01_stu$event_value[j+3]=="trip_4"& USA01_stu$event_value[j+4]=="Buy")
  city_con_ind_trip4_buy[i]<-city_con_ind_trip4_buy[i]+1

if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="concession"& USA01_stu$event_value[j+2]=="individual"
    & USA01_stu$event_value[j+3]=="trip_4"& USA01_stu$event_value[j+4]=="Cancel")
  city_con_ind_trip4_cancel[i]<-city_con_ind_trip4_cancel[i]+1

if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="concession"& USA01_stu$event_value[j+2]=="individual"
    & USA01_stu$event_value[j+3]=="trip_5"& USA01_stu$event_value[j+4]=="Buy")
  city_con_ind_trip5_buy[i]<-city_con_ind_trip5_buy[i]+1

if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="full_fare"& USA01_stu$event_value[j+2]=="individual"
    & USA01_stu$event_value[j+3]=="trip_1"& USA01_stu$event_value[j+4]=="Buy")
  country_full_ind_trip1_buy[i]<-country_full_ind_trip1_buy[i]+1
if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="full_fare"& USA01_stu$event_value[j+2]=="individual"
    & USA01_stu$event_value[j+3]=="trip_2"& USA01_stu$event_value[j+4]=="Buy")
  country_full_ind_trip2_buy[i]<-country_full_ind_trip2_buy[i]+1
if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="full_fare"& USA01_stu$event_value[j+2]=="individual"
    & USA01_stu$event_value[j+3]=="trip_3"& USA01_stu$event_value[j+4]=="Buy")
  country_full_ind_trip3_buy[i]<-country_full_ind_trip3_buy[i]+1
if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="full_fare"& USA01_stu$event_value[j+2]=="individual"
    & USA01_stu$event_value[j+3]=="trip_4"& USA01_stu$event_value[j+4]=="Buy")
  country_full_ind_trip4_buy[i]<-country_full_ind_trip4_buy[i]+1
if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="full_fare"& USA01_stu$event_value[j+2]=="individual"
    & USA01_stu$event_value[j+3]=="trip_5"& USA01_stu$event_value[j+4]=="Buy")
  country_full_ind_trip5_buy[i]<-country_full_ind_trip5_buy[i]+1

if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="concession"& USA01_stu$event_value[j+2]=="individual"
    & USA01_stu$event_value[j+3]=="trip_1"& USA01_stu$event_value[j+4]=="Buy")
  country_con_ind_trip1_buy[i]<-country_con_ind_trip1_buy[i]+1
if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="concession"& USA01_stu$event_value[j+2]=="individual"
    & USA01_stu$event_value[j+3]=="trip_2"& USA01_stu$event_value[j+4]=="Buy")
  country_con_ind_trip2_buy[i]<-country_con_ind_trip2_buy[i]+1
if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="concession"& USA01_stu$event_value[j+2]=="individual"
    & USA01_stu$event_value[j+3]=="trip_3"& USA01_stu$event_value[j+4]=="Buy")
  country_con_ind_trip3_buy[i]<-country_con_ind_trip3_buy[i]+1
if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="concession"& USA01_stu$event_value[j+2]=="individual"
    & USA01_stu$event_value[j+3]=="trip_4"& USA01_stu$event_value[j+4]=="Buy")
  country_con_ind_trip4_buy[i]<-country_con_ind_trip4_buy[i]+1
if (USA01_stu$event_value[j]=="country_trains"&USA01_stu$event_value[j+1]=="concession"& USA01_stu$event_value[j+2]=="individual"
    & USA01_stu$event_value[j+3]=="trip_5"& USA01_stu$event_value[j+4]=="Buy")
  country_con_ind_trip5_buy[i]<-country_con_ind_trip5_buy[i]+1
  }
}

##code individual_other (4)
con_ind_other_trip4<-rep(0,p)
city_con_ind_other_trip4<-rep(0,p)
con_ind_other_trip4_buy<-rep(0,p)
city_con_ind_other_trip4_buy<-rep(0,p)
trips<-c("trip_1","trip_2","trip_3","trip_4","trip_5")

for (i in 1:p){
  USA01_stu<- data_clean[which(data_clean$ID==Allstudents[i]),]
  n<-length(USA01_stu$event_value)
  n_trip4<-which(grepl("trip_4", USA01_stu$event_value))

  if (n>3&&length(n_trip4)>0)

    for (k in 1:length(n_trip4)){
      for( j in 1:n){
    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual"&prod(USA01_stu$event_value[c((j+2):n_trip4[k])]%in%trips))
      con_ind_other_trip4[i]<-con_ind_other_trip4[i]+1
    if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="concession"&USA01_stu$event_value[j+2]=="individual"&prod(USA01_stu$event_value[c((j+3):n_trip4[k])]%in%trips))
      city_con_ind_other_trip4[i]<-city_con_ind_other_trip4[i]+1
    if (USA01_stu$event_value[j]=="concession"&USA01_stu$event_value[j+1]=="individual"&prod(USA01_stu$event_value[c((j+2):n_trip4[k])]%in%trips)&USA01_stu$event_value[n-1]=="Buy"&USA01_stu$event_value[n-2]=="trip_4")
      con_ind_other_trip4_buy[i]<-con_ind_other_trip4_buy[i]+1
    if (USA01_stu$event_value[j]=="city_subway"&USA01_stu$event_value[j+1]=="concession"&USA01_stu$event_value[j+2]=="individual"&prod(USA01_stu$event_value[c((j+3):n_trip4[k])]%in%trips)&USA01_stu$event_value[n-1]=="Buy"&USA01_stu$event_value[n-2]=="trip_4")
      city_con_ind_other_trip4_buy[i]<-city_con_ind_other_trip4_buy[i]+1
    }
    }
  else next()
}
##combine daily and trip4 (7)
daily_ind_trip4<-rep(0,p)
con_daily_ind_other_trip4<-rep(0,p)
city_con_daily_ind_other_trip4<-rep(0,p)
daily.trip4<-rep(0,p)
daily.trip4_buy<-rep(0,p)
concession_daily.trip4_buy<-rep(0,p)
city_con_daily.trip4_buy<-rep(0,p)

for(i in 1:p){
  if(daily_buy[i]==0&trip4_buy[i]==0)
    daily.trip4_buy[i]<-0
  else daily.trip4_buy[i]<-1
}

for(i in 1:p){
  if(con_daily_buy[i]==0&con_ind_other_trip4_buy[i]==0)
    concession_daily.trip4_buy[i]<-0
  else concession_daily.trip4_buy[i]<-1
}

for(i in 1:p){
  if(city_con_daily_buy[i]==0&city_con_ind_other_trip4_buy[i]==0)
    city_con_daily.trip4_buy[i]<-0
  else city_con_daily.trip4_buy[i]<-1
}
for(i in 1:p){
  if(daily[i]==0&individual_trip4[i]==0)
    daily_ind_trip4[i]<-0
  else daily_ind_trip4[i]<-1
}
for(i in 1:p){
  if(daily[i]==0&trip4[i]==0)
    daily.trip4[i]<-0
  else daily.trip4[i]<-1
}
for(i in 1:p){
  if(con_ind_other_trip4[i]==0&concession_daily[i]==0)
    con_daily_ind_other_trip4[i]<-0
  else con_daily_ind_other_trip4[i]<-1
}
for(i in 1:p){
  if(city_con_daily[i]==0&city_con_ind_other_trip4[i]==0)
    city_con_daily_ind_other_trip4[i]<-0
  else city_con_daily_ind_other_trip4[i]<-1
}


#Store all generated phantem-items
unigram<-cbind.data.frame(city_subway, country_trains,full_fare,concession,
                          daily,individual,trip1,trip2,trip3,trip4,trip5,cancel,buy)
bigram<-cbind.data.frame(S_city,S_country,city_full,city_concession,city_cancel,country_full,
                         country_concession,country_cancel,concession_daily,concession_individual,
                         concession_cancel,full_daily,full_individual,full_cancel,individual_trip1,individual_trip2,
                         individual_trip3,individual_trip4,individual_trip5,individual_cancel,individual_buy,
                         trip1_cancel,trip2_cancel,trip3_cancel,trip4_cancel,trip5_cancel,daily_cancel,
                         daily_buy,trip1_buy,trip2_buy,trip3_buy,trip4_buy,trip5_buy,trip1_trip2,trip1_trip3,
                         trip1_trip4,trip1_trip5,trip2_trip1,trip2_trip3,trip2_trip4,trip2_trip5,trip3_trip1,trip3_trip2,
                         trip3_trip4,trip3_trip5,trip4_trip1,trip4_trip2,trip4_trip3,trip4_trip5,trip5_trip1,trip5_trip2,
                         trip5_trip3,trip5_trip4)
trigram<-cbind.data.frame(city_con_daily,city_con_ind,city_con_cancel,city_full_daily,city_full_ind,
                          city_full_cancel,country_con_daily,country_con_ind,country_con_cancel,country_full_daily,
                          country_full_ind,country_full_cancel,full_daily_buy,full_daily_cancel,full_individual_trip1,
                          full_individual_trip2,full_individual_trip3,full_individual_trip4,full_individual_trip5,
                          full_individual_cancel,full_individual_buy,con_daily_buy,con_daily_cancel,con_individual_trip1,
                          con_individual_trip2,con_individual_trip3,con_individual_trip4,con_individual_trip5,con_individual_cancel,
                          con_individual_buy,ind_trip1_trip2,ind_trip1_trip3,ind_trip1_trip4,ind_trip1_trip5,
                          ind_trip2_trip1,ind_trip2_trip3,ind_trip2_trip4,ind_trip2_trip5,ind_trip3_trip1,
                          ind_trip3_trip2,ind_trip3_trip4,ind_trip3_trip5,ind_trip4_trip1,ind_trip4_trip2,ind_trip4_trip3,
                          ind_trip4_trip5,ind_trip5_trip1,ind_trip5_trip2,ind_trip5_trip3,ind_trip5_trip4,ind_trip4_cancel,
                          ind_trip4_buy)

fourgram<-cbind.data.frame(city_con_daily_cancel,city_con_daily_buy,city_full_daily_cancel,city_full_daily_buy,
                           city_con_ind_cancel,city_con_ind_buy,city_full_ind_cancel,city_full_ind_buy,
                           city_con_ind_trip1,city_con_ind_trip2,city_con_ind_trip3,city_con_ind_trip4,city_con_ind_trip5,
                           city_full_ind_trip1,city_full_ind_trip2,city_full_ind_trip3,city_full_ind_trip4,
                           city_full_ind_trip5,country_con_daily_cancel,country_con_daily_buy,country_full_daily_cancel,
                           country_full_daily_buy,country_con_ind_cancel,country_con_ind_buy,country_full_ind_cancel,
                           country_full_ind_buy,country_con_ind_trip1,country_con_ind_trip2,country_con_ind_trip3,country_con_ind_trip4,
                           country_con_ind_trip5,country_full_ind_trip1,country_full_ind_trip2,country_full_ind_trip3,
                           country_full_ind_trip4,country_full_ind_trip5,full_ind_trip1_trip2,full_ind_trip1_trip3,
                           full_ind_trip1_trip4,full_ind_trip1_trip5,full_ind_trip2_trip1,full_ind_trip2_trip3,full_ind_trip2_trip4,
                           full_ind_trip2_trip5,full_ind_trip3_trip1,full_ind_trip3_trip2,full_ind_trip3_trip4,
                           full_ind_trip3_trip5,full_ind_trip4_trip1,full_ind_trip4_trip2,full_ind_trip4_trip3,
                           full_ind_trip4_trip5,full_ind_trip5_trip1,full_ind_trip5_trip3,full_ind_trip5_trip4,
                           full_ind_trip5_trip2,con_ind_trip1_trip2,con_ind_trip1_trip3,con_ind_trip1_trip4,
                           con_ind_trip1_trip5,con_ind_trip2_trip1,con_ind_trip2_trip3,con_ind_trip2_trip4,
                           con_ind_trip2_trip5,con_ind_trip3_trip1,con_ind_trip3_trip2,con_ind_trip3_trip4,con_ind_trip3_trip5,
                           con_ind_trip4_trip1,con_ind_trip4_trip2,con_ind_trip4_trip3,con_ind_trip4_trip5,con_ind_trip5_trip1,
                           con_ind_trip5_trip3,con_ind_trip5_trip4,con_ind_trip5_trip2,con_ind_trip4_cancel,con_ind_trip4_buy)
fivegram<-cbind.data.frame(city_con_ind_trip1_buy,city_con_ind_trip2_buy,city_con_ind_trip3_buy,
                           city_con_ind_trip4_buy,city_con_ind_trip5_buy,city_con_ind_trip4_cancel,
                           city_full_ind_trip1_buy,city_full_ind_trip2_buy,city_full_ind_trip3_buy,
                           city_full_ind_trip4_buy,city_full_ind_trip5_buy,country_con_ind_trip1_buy,
                           country_con_ind_trip2_buy,country_con_ind_trip3_buy,country_con_ind_trip4_buy,
                           country_con_ind_trip5_buy,country_full_ind_trip1_buy,country_full_ind_trip2_buy,
                           country_full_ind_trip3_buy,country_full_ind_trip4_buy,country_full_ind_trip5_buy)
individual_other<-cbind.data.frame(con_ind_other_trip4, city_con_ind_other_trip4,
                                   con_ind_other_trip4_buy, city_con_ind_other_trip4_buy)
dailyOrtrip4<-cbind.data.frame(daily_ind_trip4,con_daily_ind_other_trip4, city_con_daily_ind_other_trip4,
                               daily.trip4, daily.trip4_buy,concession_daily.trip4_buy, city_con_daily.trip4_buy)
allItems<-cbind.data.frame(unigram,bigram,trigram,fourgram,fivegram,individual_other,dailyOrtrip4)
allItemsBinary<-matrix(0,3760,228)
allItemsBinary[allItems!=0]<-1
sum(allItemsBinary)
colnames(allItemsBinary)<-colnames(allItems)
write.csv(allItems,"allactionsequence.csv")
write.csv(allItemsBinary,"allactionsequenceBinary.csv")
#Remove rare or excessive actions (60 remained)
sel1<-allItemsBinary[,apply(allItemsBinary,2,sum)>188]

#Remove actions not related to correct response (daily=trip4 1. OR % btw daily and trip 4; 2. ind trip4 = ind_other_trip 4)
# "city_subway"          "concession"                                           
# "cancel"               "buy"                                                  
# "city_concession"      "daily_cancel"                                     
#  "con_daily_cancel"                   
#  "city_con_daily_cancel"                      
#  "con_daily_ind_other_trip4"      "city_con_daily_ind_other_trip4"
#  "daily.trip4"                    "daily.trip4_buy"                "concession_daily.trip4_buy"    
#  "city_con_daily.trip4_buy"      
#  rare actions < 188

#####Formatted Process data: Dataset with valid actions######

items_valid<-cbind( city_subway,concession,daily.trip4,cancel,buy,
                    city_concession,
                    con_daily_ind_other_trip4,
                    city_con_daily_ind_other_trip4,
                    city_con_daily_cancel,daily_cancel,
                    con_daily_cancel,
                    daily.trip4_buy,
                    concession_daily.trip4_buy,city_con_daily.trip4_buy
)

items_valid[items_valid!=0]<-1

saveRDS(items_valid,"formatted process data.RDS")


#####Diagnostic classification analysis method for process data#####

#setwd("data file path")
install.packages("GDINA")
library("GDINA")

full_data<-items_valid
Q<-read.table("Q.txt")

#problem-solving strategies estimation#
#step 1
HOGDINA<-GDINA(dat = full_data, Q = Q, att.dist = "higher.order",higher.order = list(nquad=51, model="2PL",Prior=TRUE),withSE=TRUE,SE.type=3)
modelfit(HOGDINA)

#Reason 1 for inadequate M2: Misspecificed Q-matrix
ValQ<-Qval(HOGDINA)$sug.Q
HOGDINA2<-GDINA(dat = full_data, Q = ValQ, att.dist = "higher.order",higher.order = list(nquad=51, model="2PL",Prior=TRUE),withSE=TRUE,SE.type=3)
modelfit(HOGDINA2)#The model-data fit of HOGDINA2 is still inadequate

#Reason 2 for inadequate M2: Unfitted item 5, but retain item 5 for DINA identifiability
ifit<-itemfit(HOGDINA)
plot(ifit)

#step 2
HOGDINA1<-GDINA(dat = full_data, Q = Q, att.dist = "higher.order",higher.order = list(nquad=51, model="2PL",Prior=TRUE),withSE=TRUE,SE.type=3)
HODINA1<-GDINA(dat = full_data, Q = Q, model="DINA",att.dist = "higher.order",higher.order = list(nquad=51, model="2PL",Prior=TRUE),withSE=TRUE,SE.type=3)
HODINO1<-GDINA(dat = full_data, Q = Q, model="DINO",att.dist = "higher.order",higher.order = list(nquad=51, model="2PL",Prior=TRUE),withSE=TRUE,SE.type=3)
HOACDM1<-GDINA(dat = full_data, Q = Q, model="ACDM",att.dist = "higher.order",higher.order = list(nquad=51, model="2PL",Prior=TRUE),withSE=TRUE,SE.type=3)
anova(HOGDINA1,HODINA1,HODINO1,HOACDM1)#HODINA model is the best fitting model



sim1_itempara_gs<-coef(HODINA1,what="gs",withSE=TRUE) #guessing and slipping
sim1_pattern<-personparm(HODINA1) # attribute pattern

#attribute mastery proportions
apply(sim1_pattern,2,mean)
#mixing proportion calculated from Table 5

#attribute correlation
library(polycor)
polychor(sim1_pattern[,1],sim1_pattern[,2],std.err = TRUE, ML=TRUE)
polychor(sim1_pattern[,1],sim1_pattern[,3],std.err = TRUE, ML=TRUE)
polychor(sim1_pattern[,1],sim1_pattern[,4],std.err = TRUE, ML=TRUE)
polychor(sim1_pattern[,1],sim1_pattern[,5],std.err = TRUE, ML=TRUE)

polychor(sim1_pattern[,2],sim1_pattern[,3],std.err = TRUE, ML=TRUE)
polychor(sim1_pattern[,2],sim1_pattern[,4],std.err = TRUE, ML=TRUE)
polychor(sim1_pattern[,2],sim1_pattern[,5],std.err = TRUE, ML=TRUE)

polychor(sim1_pattern[,3],sim1_pattern[,4],std.err = TRUE, ML=TRUE)
polychor(sim1_pattern[,3],sim1_pattern[,5],std.err = TRUE, ML=TRUE)

polychor(sim1_pattern[,4],sim1_pattern[,5],std.err = TRUE, ML=TRUE)
#Examine the latent attribute patterns vs. observed scores
pattern_score_valid<-cbind.data.frame(unique(responsedata$ID),sim1_pattern)
names(pattern_score_valid)<-c("ID","A1","A2","A3","A4","A5")

pattern_score_valid<-cbind(pattern_score_valid,responsedata$CP038Q01)
names(pattern_score_valid)<-c("ID","A1","A2","A3","A4","A5","Score")

pattern_score_valid[,8]<-paste0(pattern_score_valid$A1,pattern_score_valid$A2,pattern_score_valid$A3,pattern_score_valid$A4,pattern_score_valid$A5)
names(pattern_score_valid)<-c("ID","A1","A2","A3","A4","A5","Score","Pattern")
table(pattern_score_valid[which(pattern_score_valid$Score==2),]$Pattern)
table(pattern_score_valid[which(pattern_score_valid$Score==1),]$Pattern)
table(pattern_score_valid[which(pattern_score_valid$Score==0),]$Pattern)

#output results
output1<-as.data.frame(table(pattern_score_valid[which(pattern_score_valid$Score==2),]$Pattern))
output1<-cbind(rep(2,1),output1)
output2<-as.data.frame(table(pattern_score_valid[which(pattern_score_valid$Score==1),]$Pattern))
output2<-cbind(rep(1,2),output2)
output3<-as.data.frame(table(pattern_score_valid[which(pattern_score_valid$Score==0),]$Pattern))
output3<-cbind(rep(0,26),output3)

names(output1)<-c("Score","Pattern","Frequency")
names(output2)<-c("Score","Pattern","Frequency")
names(output3)<-c("Score","Pattern","Frequency")
output<-rbind.data.frame(output1,output2,output3)

write.csv(output,"output_classes.csv")


#problem-solving ability estimation#
latent_pattner<-HODINA1$attributepattern
CDM_ability<-personparm(HODINA1,what = "HO")[,1]
CDM_ability_SE<-personparm(HODINA1,what = "HO")[,2]

install.packages("TAM")
library(TAM)
Rasch<-tam.mml(resp = as.numeric(responsedata$CP038Q01),irtmodel = "PCM")

Rasch_ability<-Rasch$person[,6]
Rasch_ability_SE<-Rasch$person[,7]

cor.test(CDM_ability,Rasch_ability)#correlation
t.test(CDM_ability_SE,Rasch_ability_SE, paired = TRUE,alternative = "less")#t-test for SE
#mean(CDM_ability_SE)
#mean(Rasch_ability_SE)

#SmoothScatter plot
smoothScatter(CDM_ability,Rasch_ability,xlim = c(-2.5,1),ylim = c(-1,1),nrpoints = 500,cex=0.5,xlab = "HO-GDINA_??1",ylab = "PCM_??2" )


#####Sensitivity Analysis#####
#reduced Q
Qreduced<-Q[c(1:6,8,10:13),]
data_reduced<-full_data[,c(1:6,8,10:13)]
write.table(Qreduced,"Qreduced.txt",col.names = FALSE,row.names = FALSE)

sim1<-GDINA(data_reduced,Qreduced,model="DINA", att.dist="higher.order",higher.order = list(model="2PL",Prior=TRUE)) #HO-DINA
sim1_pattern<-personparm(sim1) # attribute pattern

#Examine the latent attribute patterns vs. observed scores
pattern_score_valid<-cbind.data.frame(unique(responsedata$ID),sim1_pattern)
names(pattern_score_valid)<-c("ID","A1","A2","A3","A4","A5")
#pattern_score_valid<-pattern_score_valid[order(pattern_score_valid$ID),]

pattern_score_valid<-cbind(pattern_score_valid,responsedata$CP038Q01)
names(pattern_score_valid)<-c("ID","A1","A2","A3","A4","A5","Score")

pattern_score_valid[,8]<-paste0(pattern_score_valid$A1,pattern_score_valid$A2,pattern_score_valid$A3,pattern_score_valid$A4,pattern_score_valid$A5)
names(pattern_score_valid)<-c("ID","A1","A2","A3","A4","A5","Score","Pattern")
table(pattern_score_valid[which(pattern_score_valid$Score==2),]$Pattern)
table(pattern_score_valid[which(pattern_score_valid$Score==1),]$Pattern)
table(pattern_score_valid[which(pattern_score_valid$Score==0),]$Pattern)


#output results
output1<-as.data.frame(table(pattern_score_valid[which(pattern_score_valid$Score==2),]$Pattern))
output1<-cbind(rep(2,1),output1)
output2<-as.data.frame(table(pattern_score_valid[which(pattern_score_valid$Score==1),]$Pattern))
output2<-cbind(rep(1,2),output2)
output3<-as.data.frame(table(pattern_score_valid[which(pattern_score_valid$Score==0),]$Pattern))
output3<-cbind(rep(0,26),output3)

names(output1)<-c("Score","Pattern","Frequency")
names(output2)<-c("Score","Pattern","Frequency")
names(output3)<-c("Score","Pattern","Frequency")
output<-rbind.data.frame(output1,output2,output3)

write.csv(output,"output_reduced.csv")

#add redundant actions
addItems<-sel1[,c(39,40,41)]
#expanded Q
Qexpanded<-rbind(Q,c(0,1,1,0,0))
Qexpanded<-rbind(Qexpanded,c(0,0,1,1,0))
Qexpanded<-rbind(Qexpanded,c(0,0,1,0,1))
data_expanded<-cbind(full_data,addItems)

sim1<-GDINA(data_expanded,Qexpanded,model="DINA", att.dist="higher.order",higher.order = list(model="2PL",Prior=TRUE)) #HO-DINA
sim1_pattern<-personparm(sim1) # attribute pattern

write.table(Qexpanded,"Qexpanded.txt",col.names = FALSE,row.names = FALSE)
#Examine the latent attribute patterns vs. observed scores
pattern_score_valid<-cbind.data.frame(unique(responsedata$ID),sim1_pattern)
names(pattern_score_valid)<-c("ID","A1","A2","A3","A4","A5")
#pattern_score_valid<-pattern_score_valid[order(pattern_score_valid$ID),]

pattern_score_valid<-cbind(pattern_score_valid,responsedata$CP038Q01)
names(pattern_score_valid)<-c("ID","A1","A2","A3","A4","A5","Score")

pattern_score_valid[,8]<-paste0(pattern_score_valid$A1,pattern_score_valid$A2,pattern_score_valid$A3,pattern_score_valid$A4,pattern_score_valid$A5)
names(pattern_score_valid)<-c("ID","A1","A2","A3","A4","A5","Score","Pattern")
table(pattern_score_valid[which(pattern_score_valid$Score==2),]$Pattern)
table(pattern_score_valid[which(pattern_score_valid$Score==1),]$Pattern)
table(pattern_score_valid[which(pattern_score_valid$Score==0),]$Pattern)


#output results
output1<-as.data.frame(table(pattern_score_valid[which(pattern_score_valid$Score==2),]$Pattern))
output1<-cbind(rep(2,1),output1)
output2<-as.data.frame(table(pattern_score_valid[which(pattern_score_valid$Score==1),]$Pattern))
output2<-cbind(rep(1,2),output2)
output3<-as.data.frame(table(pattern_score_valid[which(pattern_score_valid$Score==0),]$Pattern))
output3<-cbind(rep(0,26),output3)

names(output1)<-c("Score","Pattern","Frequency")
names(output2)<-c("Score","Pattern","Frequency")
names(output3)<-c("Score","Pattern","Frequency")
output<-rbind.data.frame(output1,output2,output3)

write.csv(output,"output_expanded.csv")
